﻿/*jslint vars: true, plusplus: true, devel: true, nomen: true, regexp: true, indent: 4, maxerr: 50 */
/*global $, Folder*/

//SuperMosaic by Eren Goksel. Design Rocket All Rights Reserved - 2015
var uninstalled=false;


function openInPS(tempimage, gen, yuk){
    var margin_ = gen*0.2;
    gen = Number(gen) + margin_;
    yuk = Number(yuk) + margin_;
    
    
    var defaultRulerUnits = preferences.RulerUnits; 
    preferences.RulerUnits = RulerUnits.Pixels;
    var docPreset = new DocumentPreset;
    var margin = gen*0.2;
    docPreset.width = gen;
    docPreset.height = yuk;
    var docRef = documents.addDocument(DocumentColorSpace.CMYK, docPreset);
    //alert(gen + " " + yuk);
    //alert(tempimage);

try{
var doc = app.activeDocument;
var embedDoc = new File(tempimage);
var placed = doc.groupItems.createFromFile( embedDoc );
}catch(e){alert(e)}
alignToArtboard();
preferences.RulerUnits = defaultRulerUnits;
app.activeDocument.selection = null;
bringtoFront();
};



function bringtoFront() {
	try {
		BridgeTalk.bringToFront("illustrator");
	} catch (e) {
		alert(e.message)
	}
}

function alignToArtboard(){
app.coordinateSystem = CoordinateSystem.ARTBOARDCOORDINATESYSTEM; 
var doc = app.activeDocument;
var abIdx = doc.artboards.getActiveArtboardIndex();  
var actAbBds = doc.artboards[abIdx].artboardRect;  
var obj2move = doc.selection[0];  
obj2move.position = new Array ((actAbBds[2]-actAbBds[0])/2 - obj2move.width/2, (actAbBds[3]-actAbBds[1])/2  + obj2move.height/2);   
}